## pspy 1.2.1

=== Makefile ===
PROJECT_DIR = $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

BUILD_IMAGE      = local/pspy-build:latest
BUILD_DOCKERFILE = $(PROJECT_DIR)/docker/Dockerfile.build

DEV_IMAGE      = local/pspy-development:latest
DEV_DOCKERFILE = $(PROJECT_DIR)/docker/Dockerfile.development

TEST_IMAGE      = local/pspy-testing:latest
TEST_DOCKERFILE = $(PROJECT_DIR)/docker/Dockerfile.testing

VERSION      = `git describe --tags --always || echo "unknown"`
BUILD_SHA    = `git rev-parse HEAD || echo "unknown"`

# Run unit test and integration test inside container
test:
	docker build -f $(TEST_DOCKERFILE) -t $(TEST_IMAGE) . 
	docker run -it --rm $(TEST_IMAGE)

# Drops you into a shell in the development container and mounts the source code
# You can edit to source on your host, then run go commans (e.g., `go test ./...`) inside the container
dev:
	sh -c "if ! docker image ls | grep '$(DEV_IMAGE)' | cut -d ':' -f1; then echo 'building dev image'; docker build -f $(DEV_DOCKERFILE) -t $(DEV_IMAGE) .; fi"
	docker run -it \
		       --rm \
			   -v $(PROJECT_DIR):/go/src/github.com/dominicbreuker/pspy \
			   -w "/go/src/github.com/dominicbreuker/pspy" \
			   $(DEV_IMAGE)

EXAMPLE_IMAGE      = local/pspy-example:latest
EXAMPLE_DOCKERFILE = $(PROJECT_DIR)/docker/Dockerfile.example

# Run the example demonstrating what pspy does
example:
	docker build -t $(EXAMPLE_IMAGE) -f $(EXAMPLE_DOCKERFILE) .
	docker run -it --rm $(EXAMPLE_IMAGE)


# Build different binaries
# builds binaries for both 32bit and 64bit systems
# builds one set of static binaries that should work on any system without dependencies, but are huge
# builds another set of binaries that are as small as possible, but may not work 
build:
	# sh -c "if ! docker image ls | grep '$(BUILD_IMAGE)' | cut -d ':' -f1; then echo 'building build image'; docker build -f $(BUILD_DOCKERFILE) -t $(BUILD_IMAGE) .; fi"

	mkdir -p $(PROJECT_DIR)/bin
	docker run -it \
		       --rm \
		       -v $(PROJECT_DIR):/go/src/github.com/dominicbreuker/pspy \
			   -w "/go/src/github.com/dominicbreuker/pspy" \
			   --env CGO_ENABLED=0 \
			   --env GOOS=linux \
			  --env GOARCH=386 \
	           $(BUILD_IMAGE) /bin/sh -c "go build -a -ldflags '-s -w -X main.version=${VERSION} -X main.commit=${BUILD_SHA} -extldflags \"-static\"' -o bin/pspy32 main.go"
	docker run -it \
		       --rm \
		       -v $(PROJECT_DIR):/go/src/github.com/dominicbreuker/pspy \
			   -w "/go/src/github.com/dominicbreuker/pspy" \
			   --env CGO_ENABLED=0 \
			   --env GOOS=linux \
			   --env GOARCH=amd64 \
	           $(BUILD_IMAGE) /bin/sh -c "go build -a -ldflags '-s -w -X main.version=${VERSION} -X main.commit=${BUILD_SHA} -extldflags \"-static\"' -o bin/pspy64 main.go"
	docker run -it \
		       --rm \
		       -v $(PROJECT_DIR):/go/src/github.com/dominicbreuker/pspy \
			   -w "/go/src/github.com/dominicbreuker/pspy" \
			   --env GOOS=linux \
			   --env GOARCH=386 \
	           $(BUILD_IMAGE) /bin/sh -c "go build -ldflags '-w -s -X main.version=${VERSION} -X main.commit=${BUILD_SHA}' -o bin/pspy32s main.go && upx bin/pspy32s"
	docker run -it \
		       --rm \
		       -v $(PROJECT_DIR):/go/src/github.com/dominicbreuker/pspy \
			   -w "/go/src/github.com/dominicbreuker/pspy" \
			   --env GOOS=linux \
			   --env GOARCH=amd64 \
	           $(BUILD_IMAGE) /bin/sh -c "go build -ldflags '-w -s -X main.version=${VERSION} -X main.commit=${BUILD_SHA}' -o bin/pspy64s main.go && upx bin/pspy64s"

=== debian/changelog ===
pspy (1.2.1-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 15 Mar 2024 16:29:44 +0100

=== debian/control ===
Source: pspy
Section: utils
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders:
 Daniel Ruiz de Alegría <daniruiz@kali.org>,
Rules-Requires-Root: no
Build-Depends:
 ca-certificates,
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-spf13-cobra-dev,
 golang-golang-x-sys-dev,
 upx,
Standards-Version: 4.6.2
Homepage: https://github.com/DominicBreuker/pspy
Vcs-Browser: https://gitlab.com/kalilinux/packages/pspy
Vcs-Git: https://gitlab.com/kalilinux/packages/pspy.git
XS-Go-Import-Path: github.com/dominicbreuker/pspy

Package: pspy
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Description: Monitor Linux processes without root permissions
 pspy is a command line tool designed to snoop on processes without need for
 root permissions. It allows you to see commands run by other users, cron jobs,
 etc. as they execute. Great for enumeration of Linux systems in CTFs. Also
 great to demonstrate your colleagues why passing secrets as arguments on the
 command line is a bad idea.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --buildsystem=golang

override_dh_auto_build:
	mkdir $(CURDIR)/bin
	
	env GOPATH=$(CURDIR)/vendor_386_static \
		  GOCACHE=$(CURDIR)/vendor_386_static \
		  GOARCH=386 \
		  go build -a -ldflags '-s -w -X main.version=$(DEB_VERSION_UPSTREAM) -X main.commit=kali -extldflags \"-static\"' -o $(CURDIR)/bin/pspy32 main.go
	env GOPATH=$(CURDIR)/vendor_amd64_static \
		  GOCACHE=$(CURDIR)/vendor_amd64_static \
		  GOARCH=amd64 \
		  go build -a -ldflags '-s -w -X main.version=$(DEB_VERSION_UPSTREAM) -X main.commit=kali -extldflags \"-static\"' -o $(CURDIR)/bin/pspy64 main.go
	env GOPATH=$(CURDIR)/vendor_386 \
		  GOCACHE=$(CURDIR)/vendor_386 \
		  GOARCH=386 \
		  go build -ldflags '-w -s -X main.version=$(DEB_VERSION_UPSTREAM) -X main.commit=kali' -o bin/pspy32s main.go && upx $(CURDIR)/bin/pspy32s
	env GOPATH=$(CURDIR)/vendor_amd64 \
		  GOCACHE=$(CURDIR)/vendor_amd64 \
		  GOARCH=amd64 \
		  go build -ldflags '-w -s -X main.version=$(DEB_VERSION_UPSTREAM) -X main.commit=kali' -o bin/pspy64s main.go && upx $(CURDIR)/bin/pspy64s

override_dh_link:
ifeq ($(DEB_BUILD_ARCH),amd64)
	dh_link /usr/share/pspy/pspy64 /usr/bin/pspy
else
	dh_link /usr/share/pspy/pspy32 /usr/bin/pspy
endif

override_dh_dwz:

override_dh_auto_test:

override_dh_strip:

=== debian/tests/control ===
Test-Command: pspy -h
Restrictions: superficial

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/pspy-$1\.tar\.gz/ \
  https://github.com/DominicBreuker/pspy/tags .*/v?(\d\S+)\.tar\.gz
